#property copyright "Copyright  2005, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"

#property indicator_chart_window
#property indicator_buffers 1
#property indicator_color1 Blue


extern double fast   = 2;
extern double slow   = 30;
extern int P         = 2;
extern int er_span   = 20;


double ADMA[];
double PRICE[];
double dif[];


double sc_fast;
double sc_slow;


//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  { 
//---- indicators
   SetIndexStyle(0,DRAW_LINE,STYLE_SOLID);
   SetIndexBuffer(0,ADMA);

   //----      
   return(0);
  }
//+------------------------------------------------------------------+
//| Custor indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//---- 
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   
   
     int limit;
     int counted_bars=IndicatorCounted();
  //---- check for possible errors
     if(counted_bars<0) return(-1);
  //---- the last counted bar will be recounted
     if(counted_bars>0) counted_bars--;
     limit=Bars-counted_bars;
   
   
   int i,a,b,k;
   double noise, er,ssc,c;

  
sc_fast = 2/(fast+1);
sc_slow = 2/(slow+1);
   
//---- 

ArrayResize(dif,Bars); 
ArraySetAsSeries(dif,true);
ArrayResize(PRICE,Bars); 


for(i=0;i<=limit;i++){
   PRICE  [i] =Close[i];
   }

//================================================================================================= 

  for(i=0; i<=limit;i++){
     dif [i]=MathAbs(PRICE[i+1]-PRICE[i]); 
  
     }
    
 for(i=limit;i>=0;i--){
     
     noise= iMAOnArray(dif,0,er_span,0,MODE_SMA,i)*er_span;    
     if(noise!=0){ 
     er=MathAbs(PRICE[i]-PRICE[i+er_span])/noise;
     ssc = er * (sc_fast-sc_slow)+sc_slow;
     c= MathPow(ssc,P);
     }
     ADMA[i]= ADMA[i+1]  + (c*(PRICE[i]-ADMA[i+1]));
     }             


   return(0);
  }
//+------------------------------------------------------------------+














